# skalar_examples: following Mark Harris [2008] in parts

Change the line  'const int N = 100000000'  to change the vector length

### scalar_0
 - #blocks * #threads >= # vector element
 - Only one multiplication per kernel 
 - large array in global memory with kernel results
 - accumulation of kernel results on host
 - GTX 1650:  19.16 GFLOPS
 - A100    :  79.93 GFLOPS
 

### scalar_1
 - #blocks == # multi-processors on GPU
 - Stepping with large stride through data in kernel 
 - first accumulation step sequentially in one kernel per block
 - accumulation of block results on host
 - GTX 1650:  25.66 GFLOPS
 - A100    : 256.70 GFLOPS

### scalar_2
 - #blocks == # multi-processors on GPU
 - Stepping with large stride through data in kernel 
 - first accumulation step as butterfly per block
 - accumulation of block results on host
 - GTX 1650:  25.66 GFLOPS
 - A100    : 266.26 GFLOPS
 
### scalar_3_fast
 - wrapper with host function 
 - #blocks == # multi-processors on GPU
 - Stepping with large stride through data in kernel 
 - first accumulation step sequentially in one kernel per block
 - second kernel function (one block) to accumulate the above data to one number
 - checks additionally in dscapr_GPU whether the data have been transferred already.
 - GTX 1650:  25.75 GFLOPS
 - A100    : 338.69 GFLOPS

### scalar_4
 - uses cuBLAS
 - transfers data once
 - GTX 1650:  25.77 GFLOPS
 - A100    : 315.87 GFLOPS

### scalar_5
 - uses Thrust
 - transfers data once
 - GTX 1650:  25.40 GFLOPS
 - A100    : 255.56 GFLOPS


 
  
 
 
### cuSOLVERMg (MultiGPU)
Running `./lu_decomposition_cusolvermg {size} {loops} {gpus}`

### MAGMA (Single GPU || MultiGPU)
Running `./lu_decomposition_magma {size} {loops} {gpus}`
